function [L,U] = luincsparse(data,ridx,cidx)
n = length(cidx)-1;
jrow = zeros(n,1);
didx = zeros(n,1);
for j = 1:n
  idx1 = cidx(j);
  idx2 = cidx(j+1)-1;
  for i = idx1:idx2
    jrow(ridx(i)) = i;
  end  
  for idx = idx1:idx2
    k = ridx(idx);
    if (k >= j)
      break
    end
    datakj = data(idx);
    for i = didx(k)+1:cidx(k+1)-1
      ii = jrow(ridx(i));
      if (ii ~= 0)
	data(ii) = data(ii)-data(i)*datakj;
      end	
    end
  end
  didx(j) = idx; % qui si controlla che ridx(idx)==j
  if (((k ~= j) || data(idx) == 0) && idx2 > didx(j)+1)
    error('error')
  else
    for i = idx1:idx2
      jrow(ridx(i)) = 0;
    end  
    datajj = data(idx);
    for idx = didx(j)+1:idx2
      data(idx) = data(idx) / datajj;
    end
  end
end
% this part should be rewritten avoiding conversion to full
B = ccs2full(data,ridx,cidx);
L = tril(B,-1)+speye(n);
U = triu(B);
