function [As,ridx,cidx] = full2ccs(A)
% short version
[ridx,dummy,As] = find(A);
n = length(A);
cidx = zeros(n+1,1);
nnz = length(As);
cidx(1) = 1;
counter = 1;
if (nnz == 0)
  return
else
  for j = 1:nnz
    cidx(dummy(j)+1) = cidx(dummy(j)+1)+1;
  end
end
cidx = cumsum(cidx);
return
% long version
n = length(A);
As = A(A~=0);
nnz = 0;
cidx = zeros(n+1,1);
%cdidx = zeros(n,1);
cidx(1) = 1;
for j = 1:n
  for i = 1:n
    if (A(i,j) ~= 0)
      nnz = nnz + 1;
      ridx(nnz) = i;
%      if (i == j)
%	cdidx(j) = nnz;
%      end	
    end
  end
  cidx(j+1) = nnz+1;
end
if (cidx(n+1) == 0)
  ridx = zeros(0,1);
else
  ridx = ridx(:);
end
