function [L,U] = luincfull(A,varargin)
% ILU (jki), no pivoting, no fill in 
n = length(A);
B = A;
for j = 1:n
  for k = 1:j-1
    for i = k+1:n
      if (B(i,j) ~= 0)
	B(i,j) = B(i,j)-B(i,k)*B(k,j);
      end	
    end
  end
  Bjj = B(j,j);
  for i = j+1:n
    if (B(i,j) ~=0) % it preventes 0/0
      B(i,j) = B(i,j)/Bjj;
    end   
  end
end
U = triu(B);
L = tril(B,-1)+speye(n);
